﻿var R = R || {};
//
var BootState = {

    //
    init: function()
    {
        game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
        game.scale.fullScreenScaleMode = Phaser.ScaleManager.SHOW_ALL;       
        game.scale.pageAlignHorizontally = true;
        game.scale.pageAlignVertically = true;       

        //game.scale.onSizeChange.add(this.onSizeChange, this);
        game.scale.setResizeCallback(this.onResize, this);

        if(!game.device.desktop)
        {
            game.scale.forceOrientation(false, true);
            game.scale.enterIncorrectOrientation.add(this.onEnterIncorrectOrientation, this);
            game.scale.leaveIncorrectOrientation.add(this.onLeaveIncorrectOrientation, this);            
        }    

        game.input.maxPointers = 1;
        game.stage.disableVisibilityChange = false;               
    },

    //
    onResize: function()
    {
        let gameContainer = document.getElementById(game.parent);        
        gameContainer.style.height = window.innerHeight - 60 + "px";        
    },

    //
    onSizeChange: function()
    {
        this.resizeGame();
        game.state.resize(R.gameWidth, R.gameHeight);

        //console.log('onSizeChange');
    },

    //
    resizeGame: function()
    {
        let ww = window.innerWidth;
        let wh = window.innerHeight;

        R.gameHeight = R.gameWidth / ww * wh;
        R.halfGameHeight = R.gameHeight * 0.5;
        game.scale.setGameSize(R.gameWidth, R.gameHeight);

        //console.log('resizeGame');
    },

    preload: function()
    {              
        game.load.spritesheet('logo', 'assets/logo_' + R.lang + '.png', 448, 315, 3, 0, 1);
    },

    //
    create: function()
    {
        game.state.add('load', LoadState);        
        game.state.add('play', PlayState);
        game.state.add('gallery', GalleryState);

        let fontFaceObserver = new FontFaceObserver(R.fontName);
        fontFaceObserver.load(null, 5000).then(function() { game.state.start('load'); }, this.fontLoadFailed);
    },

    fontLoadFailed: function()
    {
        R.fontName = 'Arial';
        game.state.start('load');
    },

    gameContainerResize: function()
    {
        let gameContainer = document.getElementById(game.parent);
        gameContainer.style.width = window.innerWidth + "px";
        gameContainer.style.height = window.innerHeight + "px";
    },   

    onEnterIncorrectOrientation: function()
    {
        if(game.scale.incorrectOrientation)
        {
            game.paused = true;
        }
    },

    onLeaveIncorrectOrientation: function()
    {
        game.paused = false;
    },

    additionalAudioCheck: function()
    {
        //second check sound
        /*
            Sharp = SH-01F
            Fujitsu = F-01F
            Xperia A = SO-04E
            Sharp Mini = SHL24
            */

        function isStock()
        {
            var matches = window.navigator.userAgent.match(/Android.*AppleWebKit\/([\d.]+)/);
            return matches && matches[1] < 537;
        }

        let ua = navigator.userAgent; // Returns a string which tells you what device you're using
        let isSharpStock = ((/SHL24|SH-01F/i).test(ua)) && isStock(); // Checks if device is, Sharp(SH-01F) or Sharp Mini(SHL24)
        let isXperiaAStock = ((/SO-04E/i).test(ua)) && isStock(); // Checks if device is, Xperia A(SO-04E)
        let isFujitsuStock = ((/F-01F/i).test(ua)) && isStock(); // Checks if device is, Fujitsu(F-01F)

        if(isSharpStock || isXperiaAStock || isFujitsuStock) R.canAudio = false;
    }    
};