var R = R || {};

//
var GalleryState = {   

    list: null,
    listMyPicturesStarted: null,
    listMyPicturesCompleted: null,
    scrollView: null,
    scrollViewMyPicturesStarted: null,
    scrollViewMyPicturesCompleted: null,
    hudHeight: 100,
    hudTopHeight: 80,
    selectedColor: 0xff4774,
    wasTouchOnList: false,

    btnLibrary: null,
    btnMyPicture: null,

    labelEmptyMyPictures: null,

    groupOptions: null,

    ptrScrollView: null,
    ptrList: null,

    topBack: null,
    substTopButton: null,
    selectedItem: null,

    adjustItems: [],

    clearPicProgress: false,

    //
    shutdown: function()
    {
        this.wasTouchOnList = false;
        this.scrollView = null;
        this.scrollViewMyPicturesStarted = null;
        this.scrollViewMyPicturesCompleted = null;
        this.list = null;
        this.listMyPicturesStarted = null;
        this.listMyPicturesCompleted = null;
        this.btnLibrary = null;
        this.btnMyPicture = null;
        this.labelEmptyMyPictures = null;
        this.ptrList = null;
        this.ptrScrollView = null;
        this.topBack = null;
        this.substTopButton = null;
        this.adjustItems.length = 0;
        this.groupOptions = null;
        this.selectedItem = null;
    },

    //
    create: function()
    {    
        let padding = 10;        
        let d = 300;        
        let point = new Phaser.Point();
        let point2 = new Phaser.Point();

        this.list = game.add.group();

        for(let i = 0; i < 20; ++i) this.createMiniature(point, i + 1, this.list, padding + d);           

        this.list.x = (game.width - (d * 2 + padding)) * 0.5;
        this.list.y = padding;

        this.scrollView = new R.ScrollView(this.list, false, true, this.onItemTap, this, 0, this.hudHeight + 10); 

        //My Pictures list started and list completed
        this.listMyPicturesStarted = game.add.group();
        this.listMyPicturesCompleted = game.add.group();
        point.set(0, 0);

        for(let i = 0; i < R.playerData.pictures.length; ++i)
        {
            if(R.playerData.pictures[i].s == 1) this.createMiniature(point, R.playerData.pictures[i].pix, this.listMyPicturesStarted, padding + d);
            else if(R.playerData.pictures[i].s == 2) this.createMiniature(point2, R.playerData.pictures[i].pix, this.listMyPicturesCompleted, padding + d);
        }

        this.listMyPicturesStarted.x = this.list.x;
        this.listMyPicturesStarted.y = this.hudTopHeight + padding;
        this.listMyPicturesCompleted.x = this.listMyPicturesStarted.x;
        this.listMyPicturesCompleted.y = this.listMyPicturesStarted.y;

        this.scrollViewMyPicturesStarted = new R.ScrollView(this.listMyPicturesStarted, false, true, this.onItemTap, this, 0, this.hudHeight + 10);
        this.scrollViewMyPicturesCompleted = new R.ScrollView(this.listMyPicturesCompleted, false, true, this.onItemTap, this, 0, this.hudHeight + 10); 

        this.listMyPicturesStarted.visible = this.listMyPicturesCompleted.visible = false;

        //
        if(this.listMyPicturesStarted.length == 0 || this.listMyPicturesCompleted.length == 0)
        {
            let wrap = R.lang == 'jp' ? game.width - 200 : 0;
            this.labelEmptyMyPictures = R.createText(game.width * 0.5, game.height * 0.5, 40, R.strings['empty_my_pic'], '#8d8d8d', wrap, game.width - 100);
            this.labelEmptyMyPictures.visible = false;
        }

        //top hud        
        this.topBack = R.createImage(0, 0, 'gallery_back', null, 0, 0);
        let size = this.topBack.width;
        this.topBack.scale.set(game.width / size, this.hudTopHeight / size);        

        this.substTopButton = R.createImage(game.width * 0.5, this.hudTopHeight * 0.5, 'atlas', 'substrate_0');
        let btnStarted = R.createButton(-this.substTopButton.width * 0.25, 0, 'atlas', 'substrate_2', 'substrate_2', this.tapOnStarted, this);
        btnStarted.tint = this.selectedColor;
        btnStarted.addChild(R.createText(0, 4, 22, R.strings['started'], '#ffffff'));
        this.substTopButton.addChild(btnStarted);
        
        let btnCompleted = R.createButton(-btnStarted.x, btnStarted.y, 'atlas', 'substrate_2', 'substrate_2', this.tapOnCompleted, this);
        btnCompleted.addChild(R.createText(0, 4, 22, R.strings['completed'], '#333647'));
        this.substTopButton.addChild(btnCompleted);

        this.substTopButton.visible = this.topBack.visible = false;

        //
        let back = R.createImage(0, game.height, 'gallery_back', null, 0, 1);
        size = back.width;
        back.scale.set(game.width / size, this.hudHeight / size);

        this.btnLibrary = R.createButton(game.width * 0.5 - 100, game.height - 50, 'atlas', 'btn_subst', 'btn_subst_pushed', this.tapLibrary, this);            
        this.btnLibrary.addChild(R.createImage(0, 18, 'atlas', 'btn_library', 0.5, 1));
        this.btnLibrary.children[0].scale.set(1.1);
        R.createText(this.btnLibrary.x, this.btnLibrary.y + 40, 22, R.strings['library'], '#ffffff');

        this.btnMyPicture = R.createButton(game.width * 0.5 + 100, this.btnLibrary.y, 'atlas', 'btn_subst', 'btn_subst_pushed', this.tapMyPictures, this);
        this.btnMyPicture.addChild(R.createImage(0, 18, 'atlas', 'btn_palette', 0.5, 1));
        this.btnMyPicture.children[0].scale.set(0.8);
        R.createText(this.btnMyPicture.x, this.btnMyPicture.y + 40, 22, R.strings['my_pictures'], '#ffffff');

        this.btnLibrary.inputEnabled = false;

        //
        this.ptrList = this.list;
        this.ptrScrollView = this.scrollView;

        //
        this.createGroupOptions();
        this.clearPicProgress = false;

        //
        if(this.adjustItems.length > 0)
        {            
            game.load.onLoadComplete.add(this.upicsLoadComplete, this);
            game.load.start();
        }        

        //
        game.input.maxPointers = 1;
        game.input.onDown.add(this.inputOnDown, this);
        game.input.onUp.add(this.inputOnUp, this);     
    },

    createMiniature: function(point, idx, list, d)
    {       
        let ukey = 'upic' + idx;
        let checkLoad = true;
        let startedOrCompleted = false;

        let item = R.createImage(point.x, point.y, 'miniature' + idx, null, 0, 0);        
        item.idx = idx;       

        if(game.cache.checkImageKey(ukey))
        {            
            item.addChild(R.createImage(0, 0, ukey, null, 0, 0));
            checkLoad = false;
            startedOrCompleted = true;
        }

        item.addChild(R.createImage(0, 0, 'thumbnails_mask', null, 0, 0));
        list.add(item);

        point.x += d;
        if(list.length % 2 == 0)
        {
            point.x = 0;
            point.y += d;
        }

        if(checkLoad && game.device.localStorage)
        {
            let dataURL = localStorage.getItem(ukey);
            if(dataURL)
            {
                game.load.image(ukey, dataURL, true);
                this.adjustItems.push(item);
                startedOrCompleted = true;
                item.addChildAt(R.createImage(0, 0, null, null, 0, 0), 0);
            }
        } 

        item.startedOrCompleted = startedOrCompleted;

        if(this.checkCompleted(idx)) item.addChild(R.createImage(260, 40, 'atlas', 'check_completed'));       
    },

    //
    checkCompleted: function(idx)
    {
        let i = R.playerData.pictures.length;
        while(i--) if(R.playerData.pictures[i].pix == idx) return R.playerData.pictures[i].s == 2;
        return false;
    },

    //
    inputOnDown: function(pointer)
    {
        if(pointer.y < game.height - this.hudHeight && (!this.topBack.visible || pointer.y > this.hudTopHeight))
        {
            this.ptrScrollView.inputOnDown(pointer);            
            this.wasTouchOnList = true;
        }
    },

    inputOnUp: function(pointer)
    {
        if(this.wasTouchOnList) this.ptrScrollView.inputOnUp(pointer);        
        this.wasTouchOnList = false;
    },

    //
    onItemTap: function(item)
    {        
        if(item != null)
        {
            this.selectedItem = item;
            item.tint = 0xd8d7dd;
            if(item.startedOrCompleted) item.children[0].tint = item.tint;
            game.input.onDown.remove(this.inputOnDown, this);
            game.input.onUp.remove(this.inputOnUp, this);
            this.btnLibrary.inputEnabled = this.btnMyPicture.inputEnabled = false; 
            
            if(item.startedOrCompleted)
            {
                R.pictureIdx = item.idx;
                game.time.events.add(250, this.openGroupOptions, this, item);
            }
            else game.time.events.add(250, this.onItemSelect, this, item.idx);
        }
    },

    //
    onItemSelect: function(idx)
    {
        game.world.removeAll(true);
        if(this.clearPicProgress) R.removePlayerThumbnail(R.pictureIdx);
        R.createText(game.width * 0.5, game.height * 0.5, 60, R.strings['loading'], '#8d8d8d');
        game.time.events.add(1, this.loadPicture, this, idx);
    },

    //
    loadPicture: function(idx)
    {
        R.pictureKey = 'cpic' + idx;
        R.pictureIdx = idx;
       
        if(game.cache.checkImageKey(R.pictureKey)) game.state.start('play');        
        else
        {            
            game.load.image(R.pictureKey, 'pictures/' + R.pictureKey + '.png');
            game.load.json(R.pictureKey, 'numbers/' + R.pictureKey + '.json');
            game.load.onLoadComplete.add(this.loadComplete, this);
            game.load.start();
        }
    },

    //
    loadComplete: function()
    {        
        game.load.onLoadComplete.removeAll();
        game.state.start('play');
    },

    upicsLoadComplete: function()
    {       
        game.load.onLoadComplete.removeAll();
        let i = this.adjustItems.length;
        while(i--) this.adjustItems[i].children[0].loadTexture('upic' + this.adjustItems[i].idx);//this.adjustItems[i].loadTexture('upic' + this.adjustItems[i].idx);       
    },

    //
    resize: function(width, height)
    {
        
    },

    update: function()
    {
        this.ptrScrollView.update();
    },

    tapLibrary: function()
    {        
        this.substTopButton.visible = this.topBack.visible = false;

        this.btnLibrary.inputEnabled = false;
        this.btnMyPicture.inputEnabled = true;

        game.add.tween(this.btnLibrary.children[0].scale).to({ x: 1.1, y: 1.1 }, 250, Phaser.Easing.Quadratic.Out, true);
        game.add.tween(this.btnMyPicture.children[0].scale).to({ x: 0.8, y: 0.8 }, 250, Phaser.Easing.Quadratic.Out, true);

        if(this.labelEmptyMyPictures != null) this.labelEmptyMyPictures.visible = false;

        this.ptrList.visible = false;
        this.ptrList = this.list;
        this.ptrList.visible = true;
        this.ptrScrollView = this.scrollView;
    },

    tapMyPictures: function()
    {        
        this.substTopButton.visible = this.topBack.visible = true;

        this.btnLibrary.inputEnabled = true;
        this.btnMyPicture.inputEnabled = false;
        
        game.add.tween(this.btnMyPicture.children[0].scale).to({ x: 1, y: 1 }, 250, Phaser.Easing.Quadratic.Out, true);
        game.add.tween(this.btnLibrary.children[0].scale).to({ x: 0.9, y: 0.9 }, 250, Phaser.Easing.Quadratic.Out, true);       

        this.ptrList.visible = false;
        this.ptrList = this.listMyPicturesStarted;
        this.ptrList.visible = true;
        this.ptrScrollView = this.scrollViewMyPicturesStarted;

        if(this.labelEmptyMyPictures != null) this.labelEmptyMyPictures.visible = this.ptrList.length == 0;
    },

    tapOnStarted: function(button)
    {
        let btnCompleted = this.substTopButton.children[1];
        btnCompleted.tint = 0xffffff;
        btnCompleted.children[0].fill = '#333647';
        button.tint = this.selectedColor;
        button.children[0].fill = '#ffffff';

        this.ptrList.visible = false;
        this.ptrList = this.listMyPicturesStarted;
        this.ptrList.visible = true;
        this.ptrScrollView = this.scrollViewMyPicturesStarted;

        if(this.labelEmptyMyPictures != null) this.labelEmptyMyPictures.visible = this.ptrList.length == 0;
    },

    tapOnCompleted: function(button)
    {
        let btnStarted = this.substTopButton.children[0];
        btnStarted.tint = 0xffffff;
        btnStarted.children[0].fill = '#333647';
        button.tint = this.selectedColor;
        button.children[0].fill = '#ffffff';

        this.ptrList.visible = false;
        this.ptrList = this.listMyPicturesCompleted;
        this.ptrList.visible = true;
        this.ptrScrollView = this.scrollViewMyPicturesCompleted;

        if(this.labelEmptyMyPictures != null) this.labelEmptyMyPictures.visible = this.ptrList.length == 0;
    },

    createGroupOptions: function()
    {
        this.groupOptions = game.add.group();        

        let curtain = R.createImage(0, 0, 'palette_back', null, 0, 0);
        curtain.tint = 0x000000;
        curtain.alpha = 0.7;
        curtain.scale.set(game.width / curtain.width, game.height / curtain.height);        

        let btnContinue = R.createButton(game.width * 0.5, game.height * 0.5 + 100, 'atlas', 'substrate_1', 'substrate_1', this.onBtnPicContinue, this);
        let btnRestart = R.createButton(game.width * 0.5, btnContinue.y + 120, 'atlas', 'substrate_1', 'substrate_1', this.onBtnPicRestart, this);
        let btnClose = R.createButton(game.width - 50, 50, 'atlas', 'btn_close', 'btn_close_pushed', this.onBtnClose, this);

        btnContinue.addChild(R.createText(0, 5, 40, R.strings['continue'], '#ff4774', 390));
        btnRestart.addChild(R.createText(0, 5, 40, R.strings['restart'], '#ff4774', 390));

        let image = R.createImage(btnContinue.x, 300, null, null);
        image.addChild(R.createImage(0, 0, null, null));

        this.groupOptions.add(curtain);
        this.groupOptions.add(btnContinue);
        this.groupOptions.add(btnRestart);
        this.groupOptions.add(image);
        this.groupOptions.add(btnClose);

        this.groupOptions.visible = false;
    },

    openGroupOptions: function(item)
    {
        let image = this.groupOptions.children[3];
        image.loadTexture('miniature' + R.pictureIdx);
        image.children[0].loadTexture(item.children[0].key);
        image.tint = 0xffffff;
        this.groupOptions.visible = true;
    },

    onBtnPicContinue: function(button)
    {
        button.tint = 0xd8d7dd;
        button.inputEnabled = this.groupOptions.children[2].inputEnabled = this.groupOptions.children[4].inputEnabled = false;
        game.time.events.add(250, this.onItemSelect, this, R.pictureIdx);
    },

    onBtnPicRestart: function(button)
    {
        button.tint = 0xd8d7dd;
        button.inputEnabled = this.groupOptions.children[1].inputEnabled = this.groupOptions.children[4].inputEnabled = false;        
        R.removePicProgress('cpic' + R.pictureIdx);        
        R.setPicStatus(R.pictureIdx, 0);
        R.savePlayeData();
        this.clearPicProgress = true;
        game.time.events.add(250, this.onItemSelect, this, R.pictureIdx);       
    },

    onBtnClose: function()
    {
        this.groupOptions.visible = false; 
        this.btnLibrary.inputEnabled = this.btnMyPicture.inputEnabled = true;
        game.input.onDown.add(this.inputOnDown, this);
        game.input.onUp.add(this.inputOnUp, this);

        if(this.selectedItem != null)
        {
            this.selectedItem.tint = 0xffffff;
            if(this.selectedItem.startedOrCompleted) this.selectedItem.children[0].tint = this.selectedItem.tint;
            this.selectedItem = null;
        }
    }
};