﻿var R = R || {};
//
var LoadState = {
    
    logoLayer1: null,    
    logoLayer2: null, 
    step: 0,
    sfx_key: null,

    //
    init: function()
    {
        game.load.onFileComplete.add(this.fileComplete, this);
        game.load.onLoadComplete.add(this.loadComplete, this);
    },

    //
    create: function()
    {      
        game.load.path = 'assets/';        

        game.load.atlas('atlas', 'atlas.png', 'atlas.json');       
        game.load.image('palette_back', 'palette_back.png');       
        game.load.image('gallery_back', 'gallery_back.png');       
        game.load.image('thumbnails_mask', 'thumbnails_mask.png');        

        game.load.path = 'assets/thumbnails/';
        for(let i = 1; i < 21; ++i)
        {
            game.load.image('miniature' + i, 'pic' + i + '.png');
            if(game.device.localStorage)
            {                
                let k = 'upic' + i;
                let dataURL = localStorage.getItem(k);
                if(dataURL) game.load.image(k, dataURL, true);
            }
        }

        game.load.path = 'text/';
        game.load.json('strings', R.lang + '.json');      

        //
        game.load.path = 'assets/';        

        //
        this.createEnvironment();

        //
        game.load.start();
    },  

    shutdown: function()
    {        
        this.loadingBarFull = null;
        this.loadText = null;
        this.sfx_key = null;

        game.load.onFileComplete.removeAll();
        game.load.onLoadComplete.removeAll();
    },

    createEnvironment: function()
    {
        game.stage.backgroundColor = '#ffffff';
        game.canvas.parentElement.style.backgroundColor = '#000000';    

        this.logoLayer1 = game.add.image(game.world.centerX, game.world.centerY, 'logo', 0);
        this.logoLayer1.anchor.set(0.5);

        this.logoLayer2 = game.add.image(game.world.centerX, game.world.centerY, 'logo', 1);
        this.logoLayer2.anchor.set(0.5);        
    },

    //
    resize: function(width, height)
    {
        
    },

    //
    fileComplete: function(progress, cacheKey, success, totalLoaded, totalFiles)
    {
        let a = 1;

        if(this.step == 0)
        {
            if(progress <= 30) a = progress / 30;
            else
            {
                ++this.logoLayer1.frame;
                ++this.logoLayer2.frame;
                ++this.step;
            }
        }

        if(this.step == 1)
        {
            if(progress <= 60) a = (progress - 30) / 30;
            else ++this.step;
        }
            

        this.logoLayer1.alpha = 1 - a;
        this.logoLayer2.alpha = a;
    },

    //
    loadComplete: function()
    {        
        // 
        R.strings = game.cache.getJSON('strings');

        //
        R.loadPlayerData();      

        //        
        game.load.onLoadComplete.removeAll();

        //
        game.state.start('gallery');
    }
};

//
R.savePlayeData = function()
{
    if(game.device.localStorage) localStorage.setItem(R.saveFilePrefix + 'data', JSON.stringify(R.playerData));
};

//
R.loadPlayerData = function()
{
    if(game.device.localStorage)
    {
        let saveData = localStorage.getItem(R.saveFilePrefix + 'data');
        if(saveData) R.playerData = JSON.parse(saveData);
    }
};

//
R.savePicProgress = function(hittedPixels, pictureKey)
{
    if(game.device.localStorage) localStorage.setItem(R.saveFilePrefix + pictureKey, JSON.stringify(hittedPixels));    
};

//
R.removePicProgress = function(pictureKey)
{
    if(game.device.localStorage) localStorage.removeItem(R.saveFilePrefix + pictureKey);
};

//
R.loadPicProgress = function(pictureKey)
{
    if(game.device.localStorage)
    {
        let saveData = localStorage.getItem(R.saveFilePrefix + pictureKey);
        if(saveData) return JSON.parse(saveData);
    }
    return [];
};

//
R.setPicStatus = function(picIdx, status)
{    
    let i = R.playerData.pictures.length;
    while(i--)
    {
        if(R.playerData.pictures[i].pix == picIdx)
        {
            R.playerData.pictures[i].s = status;
            return;
        }
    }

    R.playerData.pictures.push({ pix: picIdx, s: status });
};

//
R.getPicStatus = function(picIdx)
{
    let i = R.playerData.pictures.length;
    while(i--) if(R.playerData.pictures[i].pix == picIdx) return R.playerData.pictures[i].s;
    return 0;
};

//
R.savePlayerThumbnail = function(srcBMD)
{
    if(!game.device.localStorage) return;

    let key = 'upic' + R.pictureIdx;
    let size = 300;
    let bmd = game.add.bitmapData(size, size);

    /*let i = srcBMD.width * srcBMD.height;
    while(i--) if(srcBMD.pixels[i] == 0xff000000) srcBMD.pixels[i] = 0;
    srcBMD.redraw();*/
    
    bmd.copy(srcBMD, 0, 0, srcBMD.width, srcBMD.height, 0, 0, size, size);
    
    localStorage.setItem(key, bmd.canvas.toDataURL('image/png'));
    bmd.destroy();  

    if(game.cache.checkImageKey(key)) game.cache.removeImage(key, true);
};

//
R.removePlayerThumbnail = function(picKey)
{
    let key = 'upic' + picKey;
    if(game.device.localStorage) localStorage.removeItem('upic' + picKey);
    if(game.cache.checkImageKey(key)) game.cache.removeImage(key, true);
};