﻿var R = R || {};

//
R.BASE_GAME_WIDTH = 640;
R.BASE_GAME_HEIGHT = 960;

R.gameWidth = R.BASE_GAME_WIDTH;
R.gameHeight = R.BASE_GAME_HEIGHT;
R.halfGameWidth = R.gameWidth * 0.5;
R.halfGameHeight = R.gameHeight * 0.5;

//
R.fontName = 'Roboto';
R.strings = null;
R.saveFilePrefix = 'Coolgames_RelaxColoring_';

//
R.canAudio = false;
R.sfx = {};
R.lang = 'en';

//
R.dragThreshold = 5;

R.scrollVelocityDamping = 0.93;
R.scrollVelocityMultiplier = 1.5;

R.pictureKey = '';
R.pictureIdx = 0;

R.playerData = {
    hints: 2,
    pictures: [] // { pix: 0, s: 0 } 1 - started, 2 - completed 
};

//
var game = null;

//
function startGame()
{
    let lang = navigator.language || navigator.userLanguage;
    if(lang == 'ja') R.lang = 'jp';

    game = new Phaser.Game(R.BASE_GAME_WIDTH, R.BASE_GAME_HEIGHT, Phaser.CANVAS, 'gameContainer', BootState);    
};

//window.onload = startGame;

//
R.selectedItem = null;

//
R.showingAd = false;

//
document.addEventListener('visibilitychange', function()
{
    // fires when user switches tabs, apps, goes to homescreen, etc.
    if(!R.showingAd && document.visibilityState == 'hidden')
    {
        if(PlayState.bmd != null && PlayState.hittedPixels.length > 0)
        {
            PlayState.deselectAreas();
            R.savePicProgress(PlayState.hittedPixels, R.pictureKey);
            R.savePlayerThumbnail(PlayState.bmd);
            R.selectedItem = PlayState.palette.selectedItem;
        }
    }

    // fires when app transitions from prerender, user returns to the app / tab.
    if(!R.showingAd && document.visibilityState == 'visible')
    {
        if(PlayState.bmd != null && R.selectedItem != null)
        {
            PlayState.onColorSelect(R.selectedItem);
            R.selectedItem = null;
        }
    }
});

//
R.createImage = function(x, y, atlas, frame, ax, ay)
{
    if(ax === undefined) ax = 0.5;
    if(ay === undefined) ay = ax;

    let image = game.add.image(x, y, atlas, frame);
    image.anchor.set(ax, ay);

    return image;
};