﻿/**
 * CoolGames SDK config. Do not change the values!
 */
var enableAds = true;
var adFreq = "AD-FREQ";
var adId = "AD-SET";
var firstAd = "FIRST-AD";
var partner = "PARTNER";
var preroll = "PRE-SET";

/**
 * CoolGames game config. Will be provided
 */
var adChannel = "hallpass_0120-relax_color";
var gameName = "Relax Coloring";
var gameCategory = "Puzzle";
var developerId = "0120";
var gameCode = "0120-relax_color";

/**
 * Load SDK
 * NOTE: path is relative and will work only after the game is published
 */
(function(w, d)
{
    w.Booster = w.Booster || {};
    var s = d.createElement("script");
    var p = d.getElementsByTagName("script")[0];
    s.async = 1;
    s.src = "/shared/booster/api.js";
    s.setAttribute("id", "booster-api");
    p.parentNode.insertBefore(s, p);
})(window, document);

/**
 * Will be automatically called when SDK is loaded
 */
Booster.ready = function()
{
    new Booster.Init({
        orientation: "portrait",
        splash: true,
        minimalUI: true,
        rotationImage: 'yahoo-landscape-warning.png',
        splashImage: 'yahoo-splashscreen.png'
    });

    adSense = new Booster.Ad({
        channelID: adChannel
    });

    community = new Booster.Community({
        position: 1,
        gameCode: gameCode,
        tabIcon: 'yahoo-menu-icon.png'
    });

    analytics = new Booster.Analytics({
        gameName: gameName,
        gameId: gameCode,
        gameCategory: gameCategory,
        developer: developerId
    });

    moregames = new Booster.Moregames();

    /**
     * Start the game
     */
    Booster.onSplashFinishedEvent = startGame;

    /**
     * Add a game pause handler
     */
    Booster.onOpenTab = function()
    {
        if(window.game)
        {
            game.paused = true;
        }
    };

    /**
     * Add a game unpause handler
     */
    Booster.onCloseTab = function()
    {
        if(window.game)
        {
            game.paused = false;
        }
    };

    banner = new Booster.AdBanner({});
    banner.show();
};

//ad
window.RewardedVideoConfig = {
    AdTech: {
        adtechZones: {
            mobile: "4103", //test id
            desktop: "4102" //test id

        }
    },
    HyperMx: {
        descriptor: {
            frameClass: "adFrame",
            adClass: "hypermx",
            width: 800,
            height: 540
        },
        distId: "80801205", //test id
        siteId: "coolgames"
    }
}

//
var Publisher = Publisher || {};

//
Publisher.showAd = function()
{
    game.paused = true;

    adSense.showAdvertising({
        callback: function()
        {
            //Here you can inform your game that ad is completed
            game.paused = false;
        }
    });
};

//
Publisher.analyticsLevelCompleted = function(levelNumber)
{
    analytics.level(levelNumber);
};